#include "pch.h"
#include "Polygon.h"

HRESULT Polygon::CreateGeometry(ID2D1Factory* factory, 
                                const std::vector<Polygon>& polygons, 
                                ID2D1PathGeometry** pathGeometry)
{
    HRESULT hr;

    if (FAILED(hr = factory->CreatePathGeometry(pathGeometry)))
        return hr;

    Microsoft::WRL::ComPtr<ID2D1GeometrySink> geometrySink;

    if (FAILED(hr = (*pathGeometry)->Open(&geometrySink)))
        return hr;

    for (const Polygon& polygon : polygons)
    {
        if (polygon.Points.size() > 0)
        {
            geometrySink->BeginFigure(polygon.Points[0], 
                                      D2D1_FIGURE_BEGIN_FILLED);

            if (polygon.Points.size() > 1)
            {
                geometrySink->AddLines(polygon.Points.data() + 1, 
                                       polygon.Points.size() - 1);
            }
            geometrySink->EndFigure(D2D1_FIGURE_END_CLOSED);
        }
    }
    return geometrySink->Close();
}